"""
@author: luojunhui
"""
import time
from applications.search import *


class SearchMethod(object):
    """
    搜索召回模式
    """
    s_words = []

    @classmethod
    async def search_v1(cls, text, trace_id):
        """
        dy ---> baidu ---> xigua
        :param text:
        :param trace_id:
        :return:
        """
        douyin_result = douyin_search(keyword=text, sensitive_words=cls.s_words, trace_id=trace_id)
        if douyin_result:
            return {"platform": "dy_search", "result": douyin_result[0]}
        else:
            time.sleep(1)
            baidu_result = hksp_search(key=text, sensitive_words=cls.s_words, trace_id=trace_id)
            if baidu_result:
                return {"platform": "baidu_search", "result": baidu_result[0]}
            else:
                xigua_result = xigua_search_v2(keyword=text, sensitive_words=cls.s_words)
                if xigua_result:
                    return {"platform": "xg_search", "result": xigua_result[0]}
                else:
                    return None

    @classmethod
    async def search_v2(cls, text, trace_id):
        """
        dy ---> baidu ---> xigua
        :param trace_id:
        :param text:
        :return:
        """
        L = []
        douyin_result = douyin_search(keyword=text, sensitive_words=cls.s_words, trace_id=trace_id)
        for vid_obj in douyin_result:
            L.append({"platform": "dy_search", "result": vid_obj})
        if len(L) >= 3:
            return L
        else:
            baidu_result = hksp_search(key=text, sensitive_words=cls.s_words, trace_id=trace_id)
            if baidu_result:
                L.append({"platform": "baidu_search", "result": baidu_result[0]})
            xigua_result = xigua_search_v2(keyword=text, sensitive_words=cls.s_words)
            if xigua_result:
                L.append({"platform": "xg_search", "result": xigua_result[0]})
            return L
