"""
@author: luojunhui
"""
import time
import datetime
import asyncio
from applications.db import AsyncMySQLClient
from tasks.newContentIdTask import NewContentIdTask


async def main():
    """
    main job
    :return:
    """
    async_mysql_pool = AsyncMySQLClient()
    await async_mysql_pool.init_pool()
    new_content_id_task = NewContentIdTask(async_mysql_pool)
    await new_content_id_task.deal()


if __name__ == '__main__':
    while True:
        asyncio.run(main())
        now_str = datetime.datetime.now().__str__()
        print("{}    请求执行完成， 等待60s".format(now_str))
        time.sleep(60)